/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.log.YYLogger
 *  fire.msp.move.GEnterDynamicScene
 *  fire.pb.GsClient
 *  fire.pb.PropRole
 *  fire.pb.event.Event
 *  fire.pb.event.Poster
 *  fire.pb.item.EnterJingYingInstEvent
 *  fire.pb.map.DuplicateHelper
 *  fire.pb.map.Transfer
 *  fire.pb.mission.SLineTask
 *  fire.pb.mission.SLineTaskConfig
 *  fire.pb.talk.MessageMgr
 *  fire.pb.team.Team
 *  fire.pb.team.TeamManager
 *  fire.pb.util.DateValidate
 *  mkdb.Lockey
 *  mkdb.Lockeys
 *  mkdb.Procedure
 *  mkdb.TTable
 *  mkio.Protocol
 *  xbean.InstanceInfo
 *  xbean.InstanceInfoCol
 *  xbean.InstanceTaskInfo
 *  xbean.Pod
 *  xtable.Instancetask
 *  xtable.Locks
 *  xtable.Roleinstancetask
 */
package fire.pb.mission.instance.line;

import fire.log.YYLogger;
import fire.msp.move.GEnterDynamicScene;
import fire.pb.GsClient;
import fire.pb.PropRole;
import fire.pb.event.Event;
import fire.pb.event.Poster;
import fire.pb.item.EnterJingYingInstEvent;
import fire.pb.map.DuplicateHelper;
import fire.pb.map.Transfer;
import fire.pb.mission.SLineTask;
import fire.pb.mission.SLineTaskConfig;
import fire.pb.mission.instance.line.LineInstManager;
import fire.pb.talk.MessageMgr;
import fire.pb.team.Team;
import fire.pb.team.TeamManager;
import fire.pb.util.DateValidate;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import mkdb.Lockey;
import mkdb.Lockeys;
import mkdb.Procedure;
import mkdb.TTable;
import mkio.Protocol;
import xbean.InstanceInfo;
import xbean.InstanceInfoCol;
import xbean.InstanceTaskInfo;
import xbean.Pod;
import xtable.Instancetask;
import xtable.Locks;
import xtable.Roleinstancetask;

public class PEnterLineMap
extends Procedure {
    private final long teamId;
    private final Integer lineId;

    public PEnterLineMap(long teamid, Integer lineId) {
        this.teamId = teamid;
        this.lineId = lineId;
    }

    protected boolean process() throws Exception {
        SLineTaskConfig config;
        SLineTask taskCofig = LineInstManager.getInstance().getInstanceTask(this.lineId);
        if (taskCofig == null) {
            return false;
        }
        Team team = TeamManager.getTeamByTeamID((long)this.teamId);
        if (team == null) {
            return false;
        }
        ArrayList<Long> roleids = new ArrayList<Long>();
        roleids.addAll(team.getNormalMemberIds());
        this.lock(Locks.ROLELOCK, roleids);
        Lockeys.lock((Lockey[])Lockeys.get((TTable)Locks.ROLEINSTANCETASK, roleids));
        long roleid = team.getTeamLeaderId();
        if (!this.checkTask(team, taskCofig, roleids)) {
            LineInstManager.logger.error((Object)("队伍中有等级不足的情况," + this.lineId));
            return false;
        }
        long currentTime = System.currentTimeMillis();
        InstanceInfoCol teamLeadreInfoCol = Roleinstancetask.get((Long)roleid);
        if (teamLeadreInfoCol == null) {
            return false;
        }
        int instanceZoneId = teamLeadreInfoCol.getLastinstanceid();
        InstanceTaskInfo teamLeadreTaskInfo = (InstanceTaskInfo)teamLeadreInfoCol.getInstinfo().get(instanceZoneId);
        if (teamLeadreTaskInfo == null) {
            return false;
        }
        if (!DateValidate.inTheSameDay((long)teamLeadreInfoCol.getAccepttime(), (long)currentTime)) {
            teamLeadreTaskInfo.getStepawardtimes().clear();
            teamLeadreTaskInfo.setCurrentstep(1);
            teamLeadreTaskInfo.setAccepttime(currentTime);
        } else {
            int step = LineInstManager.getStep(teamLeadreInfoCol, this.lineId);
            teamLeadreTaskInfo.setCurrentstep(step);
        }
        InstanceInfo instInfo = Pod.newInstanceInfo();
        long instanceOnlyId = Instancetask.insert((InstanceInfo)instInfo);
        instInfo.setOwnerid(roleid);
        if (teamLeadreTaskInfo.getCurrentstep() == 0) {
            teamLeadreTaskInfo.setCurrentstep(1);
        }
        if ((config = LineInstManager.getInstance().getTaskConfig(taskCofig.id, teamLeadreTaskInfo.getCurrentstep(), 0)) == null) {
            LineInstManager.logger.error((Object)("没有找到任务 taskType =" + this.lineId + " step" + teamLeadreTaskInfo.getCurrentstep()));
            return false;
        }
        Iterator<Number> iterator = roleids.iterator();
        while (iterator.hasNext()) {
            InstanceTaskInfo afterTaskInfo;
            InstanceTaskInfo taskInfo;
            long rid = iterator.next();
            InstanceInfoCol infoCol = Roleinstancetask.get((Long)rid);
            if (infoCol == null) {
                infoCol = Pod.newInstanceInfoCol();
                Roleinstancetask.insert((Long)rid, (InstanceInfoCol)infoCol);
            }
            if ((taskInfo = (InstanceTaskInfo)infoCol.getInstinfo().get(this.lineId)) == null) {
                taskInfo = Pod.newInstanceTaskInfo();
                infoCol.getInstinfo().put(this.lineId, taskInfo);
            }
            if (taskCofig.afterid != 0 && ((afterTaskInfo = (InstanceTaskInfo)infoCol.getInstinfo().get(taskCofig.afterid)) == null || afterTaskInfo.getState() < 2)) {
                SLineTask afterTaskCofig = LineInstManager.getInstance().getInstanceTask(taskCofig.afterid);
                if (afterTaskCofig != null) {
                    ArrayList<String> para = new ArrayList<String>(3);
                    PropRole pRole = new PropRole(rid, true);
                    para.add(pRole.getName());
                    para.add(afterTaskCofig.taskname);
                    para.add(taskCofig.taskname);
                    for (Long mem : team.getNormalMemberIds()) {
                        MessageMgr.psendMsgNotify((long)mem, (int)160439, para);
                    }
                }
                return false;
            }
            if (!DateValidate.inTheSameDay((long)infoCol.getAccepttime(), (long)currentTime)) {
                infoCol.setCounts(0);
                infoCol.getInstcount().clear();
                infoCol.setAccepttime(currentTime);
            }
            if (!DateValidate.inTheSameDay((long)taskInfo.getAccepttime(), (long)currentTime)) {
                taskInfo.setCounts(0);
                taskInfo.setCurrentstep(1);
                taskInfo.setCurrenttaskid(0);
                taskInfo.getStepawardtimes().clear();
                taskInfo.setAccepttime(currentTime);
            }
            infoCol.setLastinstanceid(this.lineId.intValue());
            taskInfo.setCurrentstep(teamLeadreTaskInfo.getCurrentstep());
            taskInfo.setCurrenttaskid(config.getTaskid());
            taskInfo.setInstanceonlyid(instanceOnlyId);
            taskInfo.setInstanceflag(4);
            taskInfo.setAwarding(1);
            YYLogger.acceptTaskLog((long)roleid, (int)this.lineId);
        }
        instInfo.getRoleids().addAll(roleids);
        instInfo.setInstanceid(this.lineId.intValue());
        instInfo.setCurrentstep(teamLeadreTaskInfo.getCurrentstep());
        instInfo.setCurrenttaskid(config.getTaskid());
        instInfo.setCurrentstate(4);
        List<Integer> mapList = LineInstManager.getInstance().getInstanceMapId(this.lineId);
        if (mapList == null) {
            return false;
        }
        for (Integer mapId : mapList) {
            DuplicateHelper.createDynamicMap((int)mapId, (long)instanceOnlyId, (String)"", (boolean)true, (int)-1, (int)0, null);
        }
        int xpos = taskCofig.getXzuobiao();
        int ypos = taskCofig.getYzuobiao();
        if (!Transfer.canChangeMap((long)roleid, (int)516022, (int)0)) {
            return false;
        }
        for (long memid : roleids) {
            Poster.getPoster().dispatchEvent((Event)new EnterJingYingInstEvent(memid));
        }
        GsClient.pSendWhileCommit((Protocol)new GEnterDynamicScene(roleid, config.getMapid(), instanceOnlyId, "", xpos, ypos, 1, 0x6DDD00, 0, 516029, null));
        return true;
    }

    private boolean checkTask(Team team, SLineTask taskCofig, List<Long> allRoleIDs) {
        ArrayList<String> levelException = new ArrayList<String>();
        for (Long mem : allRoleIDs) {
            PropRole pRole = new PropRole(mem.longValue(), true);
            if (pRole.getLevel() >= taskCofig.getMinlevel()) continue;
            levelException.add(pRole.getName());
        }
        if (!levelException.isEmpty()) {
            StringBuffer strParam = new StringBuffer();
            int nIndex = 0;
            for (String name : levelException) {
                if (nIndex != levelException.size() - 1) {
                    strParam.append(name).append(",");
                    continue;
                }
                strParam.append(name);
            }
            ArrayList<String> paras = new ArrayList<String>();
            paras.add(strParam.toString());
            paras.add(String.valueOf(taskCofig.getMinlevel()));
            for (Long mem : allRoleIDs) {
                MessageMgr.psendMsgNotifyWhileRollback((long)mem, (int)160102, paras);
            }
            return false;
        }
        if (allRoleIDs.size() < taskCofig.getTeamnum()) {
            ArrayList<String> paras = new ArrayList<String>();
            paras.add(String.valueOf(taskCofig.getTeamnum()));
            MessageMgr.psendMsgNotifyWhileRollback((long)team.getTeamLeaderId(), (int)160103, paras);
            return false;
        }
        return true;
    }
}

